#
# symmetry operators in x,y,z of conventional cell.
# 
# For the case of non-trivial centerings,
# specify only (0,0,0)+ set to generate the operators for the primitive cell.
#

function val = symopr(x,y,z)
  val = [
x,y,z,+1 
-x,-y,z,+1 
-y,x,z,+1 
y,-x,z,+1 
-x,-y,-z,+1 
x,y,-z,+1 
y,-x,-z,+1 
-y,x,-z,+1 
x,-y,-z,-1 
 -x,y,-z,-1 
 -y,-x,-z,-1 
 y,x,-z,-1 
 -x,y,z,-1 
 x,-y,z,-1 
 y,x,z,-1 
 -y,-x,z,-1
]';
endfunction

#
# form of the primitive cell in unit vectors of the conventional cell.
#
aa = [-0.5,0.5,0.5; 0.5,-0.5,0.5; 0.5,0.5,-0.5]';


x = 0;
y = 0;
z = 0;
s0f = symopr(x,y,z);
s0 = s0f(1:3,:);

x = 1;
y = 0;
z = 0;
s1f = symopr(x,y,z);
s1 = s1f(1:3,:);
s1 = s1 - s0; 

x = 0;
y = 1;
z = 0;
s2f = symopr(x,y,z);
s2 = s2f(1:3,:);
s2 = s2 = s2 - s0; 

x = 0;
y = 0;
z = 1;
s3f = symopr(x,y,z);
s3 = s3f(1:3,:);
s3 = s3 - s0; 

sym = ones(size(s0)(2),13);
for i=1:size(s0)(2)
  op = [s1(:,i),s2(:,i),s3(:,i)];
  t = int32(inv(aa)*op*aa);
  tt = mod(inv(aa)*s0(1:3,i), 1.0);
  # 
  # convert to reciprocal space operator
  #
  r = inv(t)';
  sym(i,:) = [r(1:3,1)',r(1:3,2)',r(1:3,3)',tt',s0f(4,i)];
end
symint = int32(sym);
symint

# Local Variables: ***
# mode:fundamental ***
# End: ***
