!
! Copyright (c) 2013 Yoshihide Yoshimoto
!
program diffstr
  use subr_readstr
  implicit none
  real(kind=8):: ax1,ax2
  integer:: nkd1,nsi1,nkd2,nsi2
  integer,parameter:: nf1 = 10, nf2 = 20
  !
  real(kind=8):: aa1(3,3),aa2(3,3)
  integer,pointer:: kd1(:),kd2(:)
  real(kind=8),pointer:: asi1(:,:),cforce1(:,:),asi2(:,:),cforce2(:,:)

  real(kind=8),pointer:: zo1(:),zn1(:),zo2(:),zn2(:)

  real(kind=8):: h(3)

  character(len=256):: cbuf

  integer:: ikd,it
  integer:: ios

  call getarg(1, cbuf)
  open(nf1, file=cbuf, status='old', action='read', iostat=ios)
  if (ios.ne.0) then
     write(6,*) 'error in opening '//trim(cbuf)
     stop
  end if

  call getarg(2, cbuf)
  open(nf2, file=cbuf, status='old', action='read', iostat=ios)
  if (ios.ne.0) then
     write(6,*) 'error in opening '//trim(cbuf)
     stop
  end if

  call read_strfile(nf1,nkd1,nsi1,ax1,aa1,kd1,asi1,cforce1,zo1,zn1)

  call read_strfile(nf2,nkd2,nsi2,ax2,aa2,kd2,asi2,cforce2,zo2,zn2)

  if (nsi1.ne.nsi2) then
     write(6,*) 'error: nsi1 != nsi2'
     stop
  end if
  do it=1,nsi1
     if (kd1(it).ne.kd2(it)) then
        write(6,*) 'error: different atomic kind'
        write(6,*) 'it, kd1, kd2 = ',it,kd1(it),kd2(it)
        stop
     end if
  end do

  aa1 = ax1*aa1
  aa2 = ax2*aa2

  if (maxval(abs(aa1-aa2))/maxval(abs(aa1)).gt.1.0d-8) then
     write(6,*) 'error: different cell'
     stop
  end if

  h = modulo(asi2(:,1) - asi1(:,1) + 0.5d0, 1.0d0) - 0.5d0
  write(6,'(3f16.12,'' ! '',i3,a)') h(1),h(2),h(3),kd1(1), &
       ' : displ from struct 1 in cell coord, kind'
  do it=2,nsi1
     h = modulo(asi2(:,it) - asi1(:,it) + 0.5d0, 1.0d0) - 0.5d0
     write(6,'(3f16.12,'' ! '',i3)') h(1),h(2),h(3),kd2(it)
  end do

  stop

end program diffstr
