C
C Copyright (c) 1983-2000 TAPP Consortium
C
C*****************************************************************
C                        By T. Uchiyama,   Apr. 29, 1996.
C*****************************************************************
C  From here  'P2' part
C**************************************************************
      subroutine sdos(pe,es,eferm
     &               ,ndx,ndy,ndz,nb1,nb2,nkr,nng,nsy,kz,mssg)
      implicit none
      real(kind=8):: es,eferm
      integer:: ndx,ndy,ndz,nb1,nb2,nkr,nng
      real(kind=8):: pe(nkr,nb1:nb2)
      integer:: nsy(nkr),kz(3,nkr,nng)
      integer:: mssg
c
      real(kind=8),dimension(:,:,:,:):: emesh1,emesh2
      real(kind=8),dimension(:,:):: vp1,vp2
      allocatable emesh1,emesh2,vp1,vp2
c
      integer:: ib,k,i,ierr
      real(kind=8):: sign,ee
C
C     short cut
C
      if (es.eq.eferm) then
        do ib= nb1,nb2
          do k= 1,nkr
            pe(k,ib)= 0.d0
          end do
        end do
        return
      end if
C
      allocate(emesh1(-ndx:ndx,-ndy:ndy,0:ndz,nb1:nb2),
     &     emesh2(-ndx*2:ndx*2,-ndy*2:ndy*2,0:ndz*2,nb1:nb2),
     &     vp1(nkr,nb1:nb2),vp2(nkr,nb1:nb2),
     &     stat=ierr)
      call chkalloc('SDOS','emesh',ierr)
c
      call edef(pe,emesh1,emesh2,nsy,kz
     &         ,ndx,ndy,ndz,nb1,nb2,nkr,nng)
C
      do ib= nb1,nb2
        do k= 1,nkr
          pe(k,ib)= 0.d0
        end do
      end do
C
c     write(6,*) 'ES,EFRMI=', es,eferm
      if (es.lt.eferm) then
        sign= +1.d0
      else
        sign= -1.d0
      end if
c
      do 30 i= 1,2
        sign= -sign
        if(i.eq.1) ee= es
        if(i.eq.2) ee= eferm
        if (mssg .gt. 0) then
          write(6,*) 'EE=',ee
        end if
C
        call vinteg(emesh1,kz(1,1,1),vp1,ee
     &             ,ndx,ndy,ndz,nkr,nb1,nb2)
        call vinteg(emesh2,kz(1,1,1),vp2,ee
     &             ,ndx*2,ndy*2,ndz*2,nkr,nb1,nb2)
        call rombs(pe,sign,vp1,vp2,nkr,nb1,nb2)
   30 continue
      deallocate(emesh1,emesh2,vp1,vp2)
C
      return
      end
C*********************************************************************
      subroutine rombs(pe,sign,vp1,vp2,nkr,nb1,nb2)
      implicit none
      double precision sign
      integer nkr,nb1,nb2
      double precision pe(nkr,nb1:nb2)
      double precision vp1(nkr,nb1:nb2),vp2(nkr,nb1:nb2)
      double precision third
      data third/0.3333333333333333333333333333333d0/
      integer ib,k
      double precision a
      do ib=nb1,nb2
        do k=1,nkr
          a=(vp2(k,ib)*4.0d0-vp1(k,ib))*third
          pe(k,ib)= pe(k,ib) + sign*a
        end do
      end do
      return
      end
